﻿using DevExpress.ExpressApp;
using DevExpress.Xpo;
using Xafari.BC;
using Xafari.BC.Helpers;
using Xafari.BC.Services;

namespace CustomXafariService.Module
{
    public class CustomService : XafariServiceBase<CustomService>
    {
        public class ServiceContext : ServiceSpaceContextBase
        {
            protected override void RollbackCore()
            {
                // Add here code to implement service rollback operation
                ServiceSpace.CommitChanges();
            }

            protected override void CommitChangesCore()
            {
                // Add here code to implement service commit changes operation
            }

            protected override void InitializeCore()
            {
                base.InitializeCore();
                // Add here code to implement additional initialization operation before this.ObjectSpace property is initialized.
                // Method invokes by CustomService.CreateServiceContext() after this object created.
            }

            protected override void ReloadCore()
            {
                base.ReloadCore();
            }


            public void ServiceMethod()
            {
                // Add here code to implement any service method.
            }
        }

        protected override ServiceSpaceContextBase CreateServiceContextCore(IServiceSpace serviceSpace)
        {
            return new ServiceContext();
        }

        protected override void Setup(XafApplication application)
        {
            base.Setup(application);
            // Add here code 
        }
    }

    public static class CustomServiceExtensions
    {
        public static CustomService.ServiceContext CustomService(this DataAccessorService.DataAccessor dataAccessor)
        {
            return dataAccessor.ServiceSpace.FindServiceContext<CustomService.ServiceContext>(CustomXafariService.Module.CustomService.Instance);
        }
    }
}